import java.math.* ;

/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class LargePrime {
  BigInteger x ;
  int [] ps ;

  LargePrime (BigInteger x, int [] ps) {
    this.x = x ;
    this.ps = ps ;
  }

  void combine(Collector c, BigInteger y, int [] qs) {
    System.out.print("*" + x.multiply(y) + ":") ;
    int lenp = ps.length ;
    int lenq = qs.length ;
    int ip = 0, iq = 0 ;
    int p = ps[0], q = qs[0] ;
    if (p == 0 && q == 0) {
      ip++ ; iq++ ;
      p = ps[ip] ; q = qs[iq] ;
    }
    for ( ; ; ) {
      if (p < q) {
        System.out.print((char)' ') ; System.out.print(c.seePrime(p)) ;
        ip++ ;
        if (ip >= lenp-1) break ;
        p = ps[ip] ;
      } else if (q < p) {
        System.out.print((char)' ') ; System.out.print(c.seePrime(q)) ;
        iq++ ;
        if (iq >=lenq-1) break ;
        q = qs[iq] ;
      } else {
        int prime = c.seePrime(p) ;
        System.out.print((char)' ') ; System.out.print(prime) ;
        System.out.print((char)' ') ; System.out.print(prime) ;
        ip++ ; iq++ ;
        if (ip >= lenp-1 || iq >= lenq-1) break ;
        p = ps[ip] ; q = qs[iq] ;
      }
    }
    for ( ; ip < lenp-1 ; ip++) {
      System.out.print((char)' ') ; System.out.print(c.seePrime(ps[ip])) ;
    }
    for ( ; iq < lenq-1 ; iq++) {
      System.out.print((char)' ') ; System.out.print(c.seePrime(qs[iq])) ;
    }
    System.out.print(" " + ps[ip] + " " + qs[iq]) ;
    System.out.println() ;
  }
}
