import java.math.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class Residue {
  private int [] p ;
  private int [] r ;
  private BigInteger n ;
  
  private Residue(int [] p, BigInteger n) {
    this.p = p ;
    this.n = n ;
  }

  private int [] filter() {
    int sz = p.length ;
    int [] r = new int [sz] ;
    int j = 0, i = 0 ;
    r[j++] = p[i++] ;
    r[j++] = p[i++] ;

    for ( ; i < sz ; i++) {
      if (Arith.isResidue(n,p[i]))
        r[j++] = p[i] ;
    }
    int [] rr = new int[j] ;
    for (int k = 0 ; k < j ; k++) {
      rr[k] = r[k] ;
    }
    return rr ;
  }

  static int [] compute(int [] p, BigInteger n) {
    return new Residue(p, n).filter() ;
  }
}
