import java.math.* ;
import java.util.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class Rho {

  private static BigInteger a, n ;

  static BigInteger poly(BigInteger x) {
    x = x.multiply(x) ;
    x = x.add(a) ;
    x = x.mod(n) ;
    return x ;
  }

  private static Random rnd = new Random () ;
  private static boolean over = false ;

  private static BigInteger rho(BigInteger n) {
    int len = n.bitLength() ;
    Rho.n = n ;
    Rho.a = BigInteger.ONE ;
    while (!over) {
      BigInteger s = new BigInteger(len, rnd).mod(n) ;
      BigInteger u = s ;
      BigInteger v = s ;
      while (!over) {
        u = poly(u) ;
        v = poly(poly(v)) ;
        BigInteger g = u.subtract(v).gcd(n) ;
        if (g.compareTo(n) == 0) {
          break ;
        }
        if (g.compareTo(BigInteger.ONE) != 0) {
          return g ;
        }
      }
      Rho.a =
        new BigInteger(len, rnd).mod
          (n.subtract(BigInteger.valueOf(4))).add(BigInteger.valueOf(2)) ;
    }
    return null ;
  }   

  static BigInteger timeoutRho(final int timeout, BigInteger n) {
    (new Thread () {
        public void run() {
          try { Thread.sleep(timeout) ; } catch (InterruptedException e) { } ;
          Rho.over = true ;
        }
      }).start() ;
    return rho(n) ;
  }

  public static void main(String [] arg) {
    BigInteger f = rho(new BigInteger(arg[0])) ;
    System.out.println(f) ; 
  }
}
